/* 
 * i-scream central monitoring system
 * http://www.i-scream.org.uk
 * Copyright (C) 2000-2002 i-scream
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include "ukcprog.h"
#include <string.h>
#ifdef LINUX
#include <dirent.h>
#include <unistd.h>
#include <stdlib.h>
#endif
char *get_process_stats(){
	char *xml_ps_stats;
	int zombie=0;
	int sleeping=0;
	int running=0;
	int stopped=0;
	FILE *f;
	char *line;
	char *line_p;
#ifdef LINUX
	DIR *procdir;
	struct dirent *procent;
	char fname[_POSIX_PATH_MAX];
#endif

#ifdef SOLARIS
#define SOL_PS_CMD "/bin/ps -Al"
	if((f=popen(SOL_PS_CMD, "r")) == NULL) {
		errf("Failed to execute the PS command (%m)");
		return NULL;
	}

	/* Throw away the first line as its the header from PS */
	fpgetline(f);

	while((line=fpgetline(f)) != NULL) {
      		line_p=line;
      		for(; (*line_p == ' ') && (*line_p != '\0'); line_p++);
      		line_p=strchr(line_p, ' ');
      		for(; (*line_p == ' ') && (*line_p != '\0'); line_p++);
      		if (line_p==NULL) abort();
      		/* Ok, we should now be at the state :) .. */
      		if (*line_p=='S') sleeping++;
      		if (*line_p=='R') running++;
      		if (*line_p=='Z') zombie++;
      		if (*line_p=='T') stopped++;
    	}

    	if((pclose(f)) == -1) {
        	errf("Failed to close process stats (%m)");
        	return NULL;
    	}	
#endif
#ifdef FREEBSD
#define FREEBSD_PS_CMD "/bin/ps -ax"

	if((f=popen(FREEBSD_PS_CMD, "r")) == NULL) {
		errf("Failed to execute ps");
		return NULL;
	}

	/* Throw away first line */
	fpgetline(f);
	while((line=fpgetline(f)) != NULL) {
    		line_p=line;
    		for(; (*line_p == ' ') && (*line_p != '\0'); line_p++);
    		line_p=strchr(line_p, ' ');
    		for(; (*line_p == ' ') && (*line_p != '\0'); line_p++);
    		line_p=strchr(line_p, ' ');
    		for(; (*line_p == ' ') && (*line_p != '\0'); line_p++);
    		if (line_p==NULL) abort();

    		if (*line_p=='S') sleeping++;
    		if (*line_p=='I') sleeping++;
    		if (*line_p=='R') running++;
    		if (*line_p=='D') running++;
    		if (*line_p=='Z') zombie++;
    		if (*line_p=='T') stopped++;
    		if (*line_p=='J') running++;
  	}

  	if((pclose(f)) != 0) {
    		errf("Failed to close ps (%m)");
		return NULL;
  	}
#endif
#ifdef LINUX
    	chdir("/proc");
    	if((procdir=opendir(".")) == NULL){
      		errf("Failed to open proc (%m)");
      		return NULL;
    	}

    	while((procent = readdir(procdir)) != NULL){
      		if(atoi(procent->d_name) == 0) continue;
      		strncpy(fname, procent->d_name, _POSIX_PATH_MAX-7);
      		strcat(fname, "/status");

      		if((f=fopen(fname, "r")) == NULL){
         		errf("Failed to open process stat (%m)");
			return NULL;
      		}

      		while((line=fpgetline(f)) != NULL){
         		if(strncasecmp(line,"State:",6)==0) break;
      		}

     	 	line_p=line;
      		for(;*line_p++ != '\t';);


      		if(*line_p=='R') running++;
      		if(*line_p=='S') sleeping++;
      		if(*line_p=='Z') zombie++;
      		if(*line_p=='T') stopped++;
      		if(*line_p=='D') stopped++;
			
       		if ((fclose(f)) != 0) {
			errf("Failed to close file (%m)");
		        return NULL;
	      	}

    	}
    	closedir(procdir);
#endif


	if((xml_ps_stats=strf("<processes><sleeping>%d</sleeping><cpu>%d</cpu><zombie>%d</zombie><stopped>%d</stopped><total>%d</total></processes>", sleeping, running, zombie, stopped, (sleeping+running+zombie+stopped))) == NULL){
		errf("strf failed");
		return NULL;
	}
	return xml_ps_stats;
}
